% clear all; close all; clc

% LOADING MAT FILES

load Xd.mat
load X_dE10.mat
load X_dN10.mat
load X_dS10.mat
load X_dW10.mat

load Xs.mat
load X_sE10.mat
load X_sN10.mat
load X_sS10.mat
load X_sW10.mat


% DECOMPOSE VELOCITY AND DIRECTION TO x-vel AND y-vel IN THE GRID
deg2rad = pi/180;

% origo
Xd = Xd*deg2rad;
[xvel,yvel] = pol2cart(Xd,Xs);

% N
X_dN10 = X_dN10*deg2rad;
[xvelN10,yvelN10] = pol2cart(X_dN10,X_sN10);

% E
X_dN10 = X_dN10*deg2rad;
[xvelE10,yvelE10] = pol2cart(X_dE10,X_sE10);

% S
X_dN10 = X_dN10*deg2rad;
[xvelS10,yvelS10] = pol2cart(X_dS10,X_sS10);

% W
X_dN10 = X_dN10*deg2rad;
[xvelW10,yvelW10] = pol2cart(X_dW10,X_sW10);



%% plotting
set(0,'DefaultLineLineWidth', 1.5);
set(0,'DefaultAxesXGrid','on','DefaultAxesYGrid','on');
set(0,'DefaultLineMarkerSize', 8);



be = 1+1000;
ce = 1000+1000;
% X-matrise for 1990 (uten vind)
X = [xvel(be:ce,1) yvel(be:ce,1) xvel(be:ce,2)  yvel(be:ce,2)  xvel(be:ce,3)  yvel(be:ce,3)  xvel(be:ce,4)  yvel(be:ce,4)];

de = 1001+1000; % 5000
ee = 2000+1000; % 5000
% Y-matrise for 1991 (uten vind)
%Y = [xvel(be:ce,18)];
%Y = [xvel(be:ce,5)];

Y = [xvel(be:ce,5) yvel(be:ce,5) xvel(be:ce,6) yvel(be:ce,6) xvel(be:ce,7) yvel(be:ce,7) ...
     xvel(be:ce,8) yvel(be:ce,8) xvel(be:ce,9) yvel(be:ce,9) xvel(be:ce,10) yvel(be:ce,10) ...
     xvel(be:ce,11) yvel(be:ce,11) xvel(be:ce,12) yvel(be:ce,12) xvel(be:ce,13) yvel(be:ce,13) ...
     xvel(be:ce,14) yvel(be:ce,14) xvel(be:ce,15) yvel(be:ce,15) xvel(be:ce,16) yvel(be:ce,16) ...
     xvel(be:ce,17) yvel(be:ce,17) xvel(be:ce,18) yvel(be:ce,18) ];


%% TEST SET
Xtest = [xvel(de:ee,1)  yvel(de:ee,1) xvel(de:ee,2)  yvel(de:ee,2)  xvel(de:ee,3)  yvel(de:ee,3)  xvel(de:ee,4)  yvel(de:ee,4)];

Ytest = [xvel(de:ee,5) yvel(de:ee,5) xvel(de:ee,6) yvel(de:ee,6) xvel(de:ee,7) yvel(de:ee,7) ...
         xvel(de:ee,8) yvel(de:ee,8) xvel(de:ee,9) yvel(de:ee,9) xvel(de:ee,10) yvel(de:ee,10) ...
         xvel(de:ee,11) yvel(de:ee,11) xvel(de:ee,12) yvel(de:ee,12) xvel(de:ee,13) yvel(de:ee,13) ...
         xvel(de:ee,14) yvel(de:ee,14) xvel(de:ee,15) yvel(de:ee,15) xvel(de:ee,16) yvel(de:ee,16) ...
         xvel(de:ee,17) yvel(de:ee,17) xvel(de:ee,18) yvel(de:ee,18) ];
     
%% Gaussian 

% gprMdl = fitrgp(X,y) :  fit a Gaussian process regression

% gprMdl = fitrgp(X,Y,'KernelFunction','ardsquaredexponential','FitMethod','exact',...
%    'OptimizeHyperparameters','auto','HyperparameterOptimizationOptions',...
%    struct('AcquisitionFunctionName','expected-improvement-plus'),'PredictMethod','Exact');

%%
% [ypred,~,yint] = predict(gprMdl,Xtest); % [ypred,new_yStDev,95%predictionIntervals]

%%
% figure
% t = linspace(1,length(Y),length(Y));
% plot(t,Y,'b'); hold on;
% plot(t,ypred,'r')
% plot(t,yint(:,1),'k--')
% plot(t,yint(:,2),'k--')
% 
% xlabel('Time [h]')
% ylabel('Value [cm/s]')
% h = legend({'Y','Ypred (from Xtest)'},'FontSize',10);
% set(h,'FontSize',12);
% title('Estimated value yvel at 30m (no wind included)')
% axis([0 100 -5e-3 50e-3])

% MSE:


%%%%%%%%%%% LAGER LOOP %%%%%%%%%%% 
%% (FOR  ESTIMERE FLERE VARIABLER I EN KJRING)

Y_c = mat2cell(Y,[1000],[1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1]);

Table = cell(2,1);
res2 = zeros(length(Y),28); %res
for i = 1:length(Y_c)%2
    Ytr = Y_c{i};
    gprMdl = fitrgp(X,Y_c{i},'KernelFunction','ardsquaredexponential','FitMethod','exact',...
    'OptimizeHyperparameters','auto','HyperparameterOptimizationOptions',...
    struct('AcquisitionFunctionName','expected-improvement-plus'),'PredictMethod','Exact');
    
    [ypred,~,yint] = predict(gprMdl,Xtest); 
    
    res2(:,i) = ypred;
    
%     figure
%     plot(t,Y_c{i},'b'); hold on;
%     plot(t,ypred,'r')
%     plot(t,yint(:,1),'k--')
%     plot(t,yint(:,2),'k--')
%     
%     xlabel('Time')
%     ylabel('Value')
%     legend({'Y','Ypred (from Xtest)'})
%     title('Estimated value yvel at 30m (no wind included)')
end

%[ypred,~,yint] = predict(gprMdl(i),Xtest);
%%

load resGPRestim.mat

xTing = 1:14;
[rowY,colY] = size(Y);

% (UN-NORMALIZE (AND UN-SCALE) THE DATA...)

load strdDevC.mat
load strdDevW.mat

% strength ganges med standard deviation
strdDevCcart = repelem(strdDevC,1,2);
strdDevWcart = repelem(strdDevW,1,2);

strdDevcart = [ strdDevWcart strdDevCcart ];
strdDevpol  = [ strdDevW strdDevC ];

res2 = res.*strdDevcart(:,9:end);
res = res2;

% yFit_test2 = yFit_test.*strdDevcart(:,9:end);
% yFit_test = yFit_test2;
% 
% Y_try = Y.*strdDevcart(:,9:end);
% Y = Y_try;
% 
Ytest2 = Ytest.*strdDevcart(:,9:end);
Ytest = Ytest2;


MSE = sum((Ytest-res).^2)/(rowY-1);
% MSE = Ytest-res;
% MSE = Y2 - results2;

figure
plot(xTing,MSE(1:2:end),'.-',xTing,MSE(2:2:end),'.-','MarkerSize',12); % RGB ,'Color',[.8 .2 0]
l = legend('x-vel','y-vel','Location','E');
l = set(l,'FontSize',15);
title('MSE of x- and y-velocities for testing set using GPR')
xticks([1 2 3 4 5 6 7 8 9 10 11 12 13 14])
xticklabels({'30','40','50','60','70','80','90','100','125','150','175','200','250','300'})
xlabel('depth [m]')
%axis([0 14 0 0.005])
%%
figure
plot(1:500,res(1:500,2),1:500,Xtest(1:500,2))
%%
[th_res,Rres] = cart2pol(res(:,1:2:end),res(:,2:2:end));
[th_Y,RY] = cart2pol(res(:,1:2:end),res(:,2:2:end));
%%
figure
lim = .2;
for k = 1:15
    subplot(4,4,k)
    plot([-lim lim],[-lim lim],'linewidth',2)
    hold on; grid on
    plot(Rres(:,k),RY(:,k),'mx')
    xlim([0 lim])
    a = -20+(10*k);
    b = [125 150 175 200 250 300];
    if k==1
        title('Wind')
    elseif k>9
        title(['Current ' num2str(b(k-9)) 'm depth']);
    else
        title(['Current ' num2str(a) 'm depth']);
    end
end
subplot(4,4,2)
plot(t(500:1000),rec(500:1000,1:2),'linewidth',2)
hold on; grid on
plot(t(500:1000),X(500:1000,1:2))
%legend('PC1-2 wind','PC1-2 current','TS wind','TS current')
xlabel('Time [hours]')
