close all 
clear all

deg2rad = pi/180;

%% Explore data and extend PCA analysis ...
% wind data
load dataWind19902000.mat
% 19902000:32144,19901999:29216
year = 29216;

windS = dataWind19902000(1:year,5);
windD = dataWind19902000(1:year,6);   % gikk for wd over Mdir

sU_dir = windD;
neste = 3*(1:(length(sU_dir)));
neste2 = 3:neste(end);

eU_dir = interp1(neste,sU_dir,neste2)'; % mangler de to siste pnts, m...
%ekstrapolere - nei, kutter heller punkt i strmmen

% endre retningen p vinden som er 180 i forskjell fra strmmen
for n = 1:length(eU_dir)
    eU_dir(n,1) = eU_dir(n,1) + 180;
    if eU_dir(n,1) > 360
        eU_dir(n,1) = eU_dir(n,1) - 360;
    end
end
   
%
sU_stre = windS;
neste = 3*(1:(length(sU_stre)));
neste2 = 3:neste(end);

eU_stre = interp1(neste,sU_stre,neste2)'; % mangler de to siste pnts, m...
%ekstrapolere - nei, kutter heller punkt i strmmen

windD = eU_dir;
windS = eU_stre;


% current data
load dataCurr19902000.mat

% 1990-1999 er 1:87648
% 1990-2000 er 1:96430
aar = 87646;
S0  =  dataCurr19902000(1:aar,5);
D0  =  dataCurr19902000(1:aar,6);
S10 =  dataCurr19902000(1:aar,7);
D10 =  dataCurr19902000(1:aar,8);
S20 =  dataCurr19902000(1:aar,9);
D20 =  dataCurr19902000(1:aar,10);
S30 =  dataCurr19902000(1:aar,11);
D30 =  dataCurr19902000(1:aar,12);
S40 =  dataCurr19902000(1:aar,13);
D40 =  dataCurr19902000(1:aar,14);
S50 =  dataCurr19902000(1:aar,15);
D50 =  dataCurr19902000(1:aar,16);
S60 =  dataCurr19902000(1:aar,17);
D60 =  dataCurr19902000(1:aar,18);
S70 =  dataCurr19902000(1:aar,19);
D70 =  dataCurr19902000(1:aar,20);
S80 =  dataCurr19902000(1:aar,21);
D80 =  dataCurr19902000(1:aar,22);
S90 =  dataCurr19902000(1:aar,23);
D90 =  dataCurr19902000(1:aar,24);
S100 = dataCurr19902000(1:aar,25);
D100 = dataCurr19902000(1:aar,26);
S125 = dataCurr19902000(1:aar,27);
D125 = dataCurr19902000(1:aar,28);
S150 = dataCurr19902000(1:aar,29);
D150 = dataCurr19902000(1:aar,30);
S175 = dataCurr19902000(1:aar,31);
D175 = dataCurr19902000(1:aar,32);
S200 = dataCurr19902000(1:aar,33);
D200 = dataCurr19902000(1:aar,34);
S250 = dataCurr19902000(1:aar,35);
D250 = dataCurr19902000(1:aar,36);
S300 = dataCurr19902000(1:aar,37);
D300 = dataCurr19902000(1:aar,38);

%% More points, extreme values N-E-S-W

load dataNCurr19901999
load dataNWind19901999

temp_xN = dataNCurr19901999(1:87646,:);

X_sN = temp_xN(:,1:2:33);
X_dN = temp_xN(:,2:2:34);

wind_sN = dataNWind19901999(:,1);
wind_dN = dataNWind19901999(:,2);

% interpolerer vind for  f rett dim
sU_dir = wind_dN;
neste = 3*(1:(length(sU_dir)));
neste2 = 3:neste(end);

eU_dir = interp1(neste,sU_dir,neste2)'; % mangler de to siste pnts, m...
%ekstrapolere - nei, kutter heller punkt i strmmen

% endre retningen p vinden som er 180 i forskjell fra strmmen
for n = 1:length(eU_dir)
    eU_dir(n,1) = eU_dir(n,1) + 180;
    if eU_dir(n,1) > 360
        eU_dir(n,1) = eU_dir(n,1) - 360;
    end
end
   
sU_stre = wind_sN;
neste = 3*(1:(length(sU_stre)));
neste2 = 3:neste(end);

eU_stre = interp1(neste,sU_stre,neste2)'; % mangler de to siste pnts, m...
%ekstrapolere - nei, kutter heller punkt i strmmen

wind_dN = eU_dir;
wind_sN = eU_stre;

X_sN = [wind_sN*100 X_sN];
X_dN = [wind_dN X_dN];


load dataECurr19901999
load dataEWind19901999

temp_xE = dataECurr19901999(1:87646,:);



X_sE = temp_xE(:,1:2:33);
X_dE = temp_xE(:,2:2:34);

wind_sE = dataEWind19901999(:,1);
wind_dE = dataEWind19901999(:,2);

wind_dE(617:618,1) = [242 255]';
%%
% interpolerer vind for  f rett dim
sU_dir = wind_dE;
neste = 3*(1:(length(sU_dir)));
neste2 = 3:neste(end);

eU_dir = interp1(neste,sU_dir,neste2)'; % mangler de to siste pnts, m...
%ekstrapolere - nei, kutter heller punkt i strmmen

% endre retningen p vinden som er 180 i forskjell fra strmmen
for n = 1:length(eU_dir)
    eU_dir(n,1) = eU_dir(n,1) + 180;
    if eU_dir(n,1) > 360
        eU_dir(n,1) = eU_dir(n,1) - 360;
    end
end
   
sU_stre = wind_sE;
neste = 3*(1:(length(sU_stre)));
neste2 = 3:neste(end);

eU_stre = interp1(neste,sU_stre,neste2)'; % mangler de to siste pnts, m...
%ekstrapolere - nei, kutter heller punkt i strmmen

wind_dE = eU_dir;
wind_sE = eU_stre;

X_sE = [wind_sE*100 X_sE];
X_dE = [wind_dE X_dE];


load dataSCurr19901999
load dataSWind19901999

temp_xS = dataSCurr19901999(1:87646,:);

X_sS = temp_xS(:,1:2:33);
X_dS = temp_xS(:,2:2:34);

wind_sS = dataSWind19901999(:,1);
wind_dS = dataSWind19901999(:,2);

% interpolerer vind for  f punkt hver time som 
sU_dir = wind_dS;
neste = 3*(1:(length(sU_dir)));
neste2 = 3:neste(end);

eU_dir = interp1(neste,sU_dir,neste2)'; % mangler de to siste pnts, m...
%ekstrapolere - nei, kutter heller punkt i strmmen

% endre retningen p vinden som er 180 i forskjell fra strmmen
for n = 1:length(eU_dir)
    eU_dir(n,1) = eU_dir(n,1) + 180;
    if eU_dir(n,1) > 360
        eU_dir(n,1) = eU_dir(n,1) - 360;
    end
end
   
sU_stre = wind_sS;
neste = 3*(1:(length(sU_stre)));
neste2 = 3:neste(end);

eU_stre = interp1(neste,sU_stre,neste2)'; % mangler de to siste pnts, m...
%ekstrapolere - nei, kutter heller punkt i strmmen

wind_dS = eU_dir;
wind_sS = eU_stre;

X_sS = [wind_sS*100 X_sS];
X_dS = [wind_dS X_dS];

load dataWCurr19901999
load dataWWind19901999

temp_xW = dataWCurr19901999(1:87646,:);

X_sW = temp_xW(:,1:2:33);
X_dW = temp_xW(:,2:2:34);

wind_sW = dataWWind19901999(:,1);
wind_dW = dataWWind19901999(:,2);

% interpolerer vind for  f rett dim
sU_dir = wind_dW;
neste = 3*(1:(length(sU_dir)));
neste2 = 3:neste(end);

eU_dir = interp1(neste,sU_dir,neste2)'; % mangler de to siste pnts, m...
%ekstrapolere - nei, kutter heller punkt i strmmen

% endre retningen p vinden som er 180 i forskjell fra strmmen
for n = 1:length(eU_dir)
    eU_dir(n,1) = eU_dir(n,1) + 180;
    if eU_dir(n,1) > 360
        eU_dir(n,1) = eU_dir(n,1) - 360;
    end
end
   
sU_stre = wind_sW;
neste = 3*(1:(length(sU_stre)));
neste2 = 3:neste(end);

eU_stre = interp1(neste,sU_stre,neste2)'; % mangler de to siste pnts, m...
%ekstrapolere - nei, kutter heller punkt i strmmen

wind_dW = eU_dir;
wind_sW = eU_stre;

X_sW = [wind_sW*100 X_sW];
X_dW = [wind_dW X_dW];



%%
% strength
X_s = [windS*100 S0 S10 S20 S30 S40 S50 S60 S70 S80 S90 S100...
    S125 S150 S175 S200 S250 S300]; % w:m/s, c:cm/s => w*100

% direction
X_d = [windD D0 D10 D20 D30 D40 D50 D60 D70 D80 D90 D100...
    D125 D150 D175 D200 D250 D300];

%normalizing and rescaling strength
X_S = normalize(X_s,'range');
X_S = rescale(X_s,0,1); %bytte til range 0 til 1 (rar med -1 til 1 => pga neg?)

X_sN = normalize(X_sN,'range');
X_sN = rescale(X_sN,0,1);

X_sE = normalize(X_sE,'range');
X_sE = rescale(X_sE,0,1);

X_sS = normalize(X_sS,'range');
X_sS = rescale(X_sS,0,1);

X_sW = normalize(X_sW,'range');
X_sW = rescale(X_sW,0,1);

%% Interpolere spatially N-E-S-W

% interpolerer strm og vind for  f rett avstand mellom NESW og midten

avst = 10; % distanse p nsket punkt fra senterpunkt, 10 betyr 10 km fra null

% N

spatialN = [1 51]; % andre punkt 51 km fra senterpunkt

  % strength
A_N = cat(3,X_S,X_sN);
B_N = permute(A_N,[3,2,1]);

x_interpolated_N = interp1(spatialN,B_N,avst);

X_sN10 = ipermute(x_interpolated_N,[3,2,1]);

  % direction
A_NN = cat(3,X_d,X_dN);
B_NN = permute(A_NN,[3,2,1]);

x_interpolated_NN = interp1(spatialN,B_NN,avst);

X_dN10 = ipermute(x_interpolated_NN,[3,2,1]);


%% E

spatialE = [1 37]; % andre punkt 37 km fra senterpunkt

  % strength
A_E = cat(3,X_S,X_sE);
B_E = permute(A_E,[3,2,1]);

x_interpolated_E = interp1(spatialE,B_E,avst);

X_sE10 = ipermute(x_interpolated_E,[3,2,1]);

  % direction
A_EE = cat(3,X_d,X_dE);
B_EE = permute(A_EE,[3,2,1]);

x_interpolated_EE = interp1(spatialE,B_EE,avst);

X_dE10 = ipermute(x_interpolated_EE,[3,2,1]);
  
  
%% S

spatialS = [1 51]; % andre punkt 51 km fra senterpunkt

  % strength
A_S = cat(3,X_S,X_sS);
B_S = permute(A_S,[3,2,1]);

x_interpolated_S = interp1(spatialS,B_S,avst);

X_sS10 = ipermute(x_interpolated_S,[3,2,1]);

  % direction
A_SS = cat(3,X_d,X_dS);
B_SS = permute(A_SS,[3,2,1]);

x_interpolated_SS = interp1(spatialS,B_SS,avst);

X_dS10 = ipermute(x_interpolated_EE,[3,2,1]);
  
%% W

spatialW = [1 33]; % andre punkt 33 km fra senterpunkt

  % strength
A_W = cat(3,X_S,X_sW);
B_W = permute(A_W,[3,2,1]);

x_interpolated_W = interp1(spatialW,B_W,avst);

X_sW10 = ipermute(x_interpolated_W,[3,2,1]);

  % direction
A_WW = cat(3,X_d,X_dW);
B_WW = permute(A_WW,[3,2,1]);

x_interpolated_WW = interp1(spatialW,B_WW,avst);

X_dW10 = ipermute(x_interpolated_WW,[3,2,1]);
  
  

%% dekomponerer vektoren i x og y

Xd = X_d*deg2rad;
Xs = X_S;

[xvel,yvel] = pol2cart(Xd,Xs);

% p2 = atan2(yvel,xvel); %skulle teste, men ble ikke heeelt rett. Bruk cart2pol evt

figure
title('Decomposed x- and y-velocity')
plot(xvel(:,:),yvel(:,:),'*','MarkerSize',5)
grid on; hold on;
xlabel('x-velocity')
ylabel('y-velocity')
%plot(xvel(:,1),yvel(:,1),'*') % wind alone

% N
X_dN = X_dN*deg2rad;
[xvelN,yvelN] = pol2cart(X_dN,X_sN);

X_dN10 = X_dN10*deg2rad;
[xvelN10,yvelN10] = pol2cart(X_dN10,X_sN10);

% E
X_dE = X_dE*deg2rad;
[xvelE,yvelE] = pol2cart(X_dE,X_sE);

X_dN10 = X_dN10*deg2rad;
[xvelE10,yvelE10] = pol2cart(X_dE10,X_sE10);

% S
X_dS = X_dS*deg2rad;
[xvelS,yvelS] = pol2cart(X_dS,X_sS);

X_dN10 = X_dN10*deg2rad;
[xvelS10,yvelS10] = pol2cart(X_dS10,X_sS10);

% W
X_dW = X_dW*deg2rad;
[xvelW,yvelW] = pol2cart(X_dW,X_sW);

X_dN10 = X_dN10*deg2rad;
[xvelW10,yvelW10] = pol2cart(X_dW10,X_sW10);

% %% plotting
% set(0,'DefaultLineLineWidth', 1.5);
% set(0,'DefaultAxesXGrid','on','DefaultAxesYGrid','on');
% set(0,'DefaultLineMarkerSize', 8);
% % set(0,'DefaultAxesMarkerSize',8);
% 
% %% PCA analyse
% 
% % [coeff,score,latent,tsquared,explained,mu] = pca(X_S);   
% 
% %% PLSR prep (sette opp matriser)
% 
% % 1990, 1991, 1993, 1994, 1995, 1997, 1998, 1999 : 8759 punkter
% % 1992, 1996: 8783 punkter
% 
% % % X-matrise for januar 1990 (uten vind)
% % X = [xvel(1:744,2)  yvel(1:744,2)  xvel(1:744,3)  yvel(1:744,3)  xvel(1:744,4)  yvel(1:744,4)...
% %      xvel(1:744,5)  yvel(1:744,5)  xvel(1:744,6)  yvel(1:744,6)  xvel(1:744,7)  yvel(1:744,7)...
% %      xvel(1:744,8)  yvel(1:744,8)  xvel(1:744,9)  yvel(1:744,9)  xvel(1:744,10) yvel(1:744,10)...
% %      xvel(1:744,11) yvel(1:744,11) xvel(1:744,12) yvel(1:744,12) xvel(1:744,13) yvel(1:744,13)...
% %      xvel(1:744,14) yvel(1:744,14) xvel(1:744,15) yvel(1:744,15) xvel(1:744,16) yvel(1:744,16)...
% %      xvel(1:744,17) yvel(1:744,17)];
% % 
% % % Y-matrise for januar 1991 (uten vind)
% % Y = [xvel(8760:9503,2)  yvel(8760:9503,2)  xvel(8760:9503,3)  yvel(8760:9503,3)  xvel(8760:9503,4)  yvel(8760:9503,4)...
% %      xvel(8760:9503,5)  yvel(8760:9503,5)  xvel(8760:9503,6)  yvel(8760:9503,6)  xvel(8760:9503,7)  yvel(8760:9503,7)...
% %      xvel(8760:9503,8)  yvel(8760:9503,8)  xvel(8760:9503,9)  yvel(8760:9503,9)  xvel(8760:9503,10) yvel(8760:9503,10)...
% %      xvel(8760:9503,11) yvel(8760:9503,11) xvel(8760:9503,12) yvel(8760:9503,12) xvel(8760:9503,13) yvel(8760:9503,13)...
% %      xvel(8760:9503,14) yvel(8760:9503,14) xvel(8760:9503,15) yvel(8760:9503,15) xvel(8760:9503,16) yvel(8760:9503,16)...
% %      xvel(8760:9503,17) yvel(8760:9503,17)];
%  
% be = 1;
% ce = 8759;
% % X-matrise for 1990 (uten vind)
% X = [xvel(be:ce,2)  yvel(be:ce,2)  xvel(be:ce,3)  yvel(be:ce,3)  xvel(be:ce,4)  yvel(be:ce,4)...
%      xvel(be:ce,5)  yvel(be:ce,5)  xvel(be:ce,6)  yvel(be:ce,6)  xvel(be:ce,7)  yvel(be:ce,7)...
%      xvel(be:ce,8)  yvel(be:ce,8)  xvel(be:ce,9)  yvel(be:ce,9)  xvel(be:ce,10) yvel(be:ce,10)...
%      xvel(be:ce,11) yvel(be:ce,11) xvel(be:ce,12) yvel(be:ce,12) xvel(be:ce,13) yvel(be:ce,13)...
%      xvel(be:ce,14) yvel(be:ce,14) xvel(be:ce,15) yvel(be:ce,15) xvel(be:ce,16) yvel(be:ce,16)...
%      xvel(be:ce,17) yvel(be:ce,17)];
% 
% de = 8760;
% ee = 8759*2;
% % Y-matrise for 1991 (uten vind)
% Y = [xvel(de:ee,2)  yvel(de:ee,2)  xvel(de:ee,3)  yvel(de:ee,3)  xvel(de:ee,4)  yvel(de:ee,4)...
%      xvel(de:ee,5)  yvel(de:ee,5)  xvel(de:ee,6)  yvel(de:ee,6)  xvel(de:ee,7)  yvel(de:ee,7)...
%      xvel(de:ee,8)  yvel(de:ee,8)  xvel(de:ee,9)  yvel(de:ee,9)  xvel(de:ee,10) yvel(de:ee,10)...
%      xvel(de:ee,11) yvel(de:ee,11) xvel(de:ee,12) yvel(de:ee,12) xvel(de:ee,13) yvel(de:ee,13)...
%      xvel(de:ee,14) yvel(de:ee,14) xvel(de:ee,15) yvel(de:ee,15) xvel(de:ee,16) yvel(de:ee,16)...
%      xvel(de:ee,17) yvel(de:ee,17)];
%  
%  
% % be = 1;
% % ce = 8759*2;
% % % X-matrise for 1990 - 1991 (uten vind)
% % X = [xvel(be:ce,2)  yvel(be:ce,2)  xvel(be:ce,3)  yvel(be:ce,3)  xvel(be:ce,4)  yvel(be:ce,4)...
% %      xvel(be:ce,5)  yvel(be:ce,5)  xvel(be:ce,6)  yvel(be:ce,6)  xvel(be:ce,7)  yvel(be:ce,7)...
% %      xvel(be:ce,8)  yvel(be:ce,8)  xvel(be:ce,9)  yvel(be:ce,9)  xvel(be:ce,10) yvel(be:ce,10)...
% %      xvel(be:ce,11) yvel(be:ce,11) xvel(be:ce,12) yvel(be:ce,12) xvel(be:ce,13) yvel(be:ce,13)...
% %      xvel(be:ce,14) yvel(be:ce,14) xvel(be:ce,15) yvel(be:ce,15) xvel(be:ce,16) yvel(be:ce,16)...
% %      xvel(be:ce,17) yvel(be:ce,17)];
% % 
% % de = 8759*3+1;
% % ee = 8759*4;
% % % Y-matrise for 1993 (uten vind)
% % Y = [xvel(de:ee,2)  yvel(de:ee,2)  xvel(de:ee,3)  yvel(de:ee,3)  xvel(de:ee,4)  yvel(de:ee,4)...
% %      xvel(de:ee,5)  yvel(de:ee,5)  xvel(de:ee,6)  yvel(de:ee,6)  xvel(de:ee,7)  yvel(de:ee,7)...
% %      xvel(de:ee,8)  yvel(de:ee,8)  xvel(de:ee,9)  yvel(de:ee,9)  xvel(de:ee,10) yvel(de:ee,10)...
% %      xvel(de:ee,11) yvel(de:ee,11) xvel(de:ee,12) yvel(de:ee,12) xvel(de:ee,13) yvel(de:ee,13)...
% %      xvel(de:ee,14) yvel(de:ee,14) xvel(de:ee,15) yvel(de:ee,15) xvel(de:ee,16) yvel(de:ee,16)...
% %      xvel(de:ee,17) yvel(de:ee,17)];
% 
% 
% % PLSR analysen
% ncomp = 32;
% 
% [XL,YL,XS,YS,BETA,PCTvar,MSE,stats] = plsregress(X,Y,ncomp);
% % [XL10,YL10,XS10,YS10,BETAPLS10,PCTvar10,MSE10,stats10] = plsregress(X,Y,ncomp);
% 
% figure
% plot(1:ncomp,cumsum(100*PCTvar(2,:)),'-bo');
% xlabel('Number of PLS components');
% ylabel('Cumulative percent variance explained in Y');
% grid on
% 
% [n,p] = size(X);
% 
% % Compute fitted response values for 2-comp model and display residuals (stem)
% 
% yFit = [ones(size(X,1),1) X]*BETA;
% %residuals = Y - yFit;
% residuals = sqrt(yFit.^2 - Y.^2);
% figure
% 
% % stem(residuals)
% % xlabel('Observation');
% % ylabel('Residual');
% 
% % title('Error plot from PLS regression')
% % plot(time,Y,time,yFit)
% % xlabel('Time') % lage datenum og bruke den! kanskje bruke 1000 points
% % ylabel('X') % litt usikker p hvordan dette skal funke..
% % legend({'Y','\hat{Y}'})
% 
% % figure
% % percResid = (residuals/Y)*100;
% % plot(percResid)
% 
% % PCR vha PCA
% 
% [PCAcoeff,PCAscore,PCAlatent,PCAtsq,PCAexplained] = pca(X,'Economy',false); % loading, score, var, tsquared, explained, mu
% figure
% plot(1:ncomp,cumsum(PCAexplained(1:ncomp,1)),'-mo')
% xlabel('Number of PCA components');
% ylabel('Percent variance explained in Y');
% 
% betaPCR = regress(Y(:,1)-mean(Y(:,1)),PCAscore(:,1:3));
% % transform to regression coeffs for original uncentered variables
% betaPCR = PCAcoeff(:,1:3)*betaPCR;
% betaPCR = [mean(Y(:,1))-mean(X)*betaPCR;betaPCR];
% yfitPCR = [ones(n,1) X]*betaPCR;
% 
% %%
% % plotting fitted vs observed response to compare fits with PLSR and PCR
% figure
% title('Similarity between fitted and observed response for PLSR and PCR')
% plot(Y,yFit,'bo',Y,yfitPCR,'m^','MarkerSize',4); hold on;
% 
% t = linspace(0,2*pi,1000);
% theta0 = pi/4;
% a=0.02;
% b=0.0065;
% % x = a*sin(t+theta0);
% x = a*cos(t)*cos(theta0) - b*sin(t)*sin(theta0);
% % y = b*cos(t);
% y = b*sin(t)*cos(theta0) + a*cos(t)*sin(theta0);
% plot(x,y)
% 
% xlabel('Observed response');
% ylabel('Fitted response');
% legend({'PLSR with 32 components' 'PCR with 32 components'},'location','NW');
% axis([-0.025 0.025 -0.025 0.025]) %equal
% 
% % r-squared-verdi? M da skrive om i teori! (another way to compare the predictive power between the two models)
% 
% % better fitting with more components (nops, de mener mer predictors (flere PCs))
