%clear all; clc; close all;

load MM.mat 
load MMN10.mat 
load MME10.mat 
load MMS10.mat 
load MMW10.mat

%% Retter opp i retninger (hvor 180 garder er lagt til vind undvendig)
tmp1 = str2double(MM(:,2:3)); % middle pnt
[tmp1_th,tmp1_rho] = cart2pol(tmp1(:,1),tmp1(:,2));

tmp2 = str2double(MMN10(:,2:3)); % N10
[tmp2_th,tmp2_rho] = cart2pol(tmp2(:,1),tmp2(:,2));

tmp3 = str2double(MME10(:,2:3)); % E10
[tmp3_th,tmp3_rho] = cart2pol(tmp3(:,1),tmp3(:,2));

tmp4 = str2double(MMS10(:,2:3)); % S10
[tmp4_th,tmp4_rho] = cart2pol(tmp4(:,1),tmp4(:,2));

tmp5 = str2double(MMW10(:,2:3)); % W10
[tmp5_th,tmp5_rho] = cart2pol(tmp5(:,1),tmp5(:,2));


for n = 1:length(tmp1_th) % middle pnt
    tmp1_th(n,1) = tmp1_th(n,1) + 180;
    if tmp1_th(n,1) > 360
        tmp1_th(n,1) = tmp1_th(n,1) - 360;
    end
end
for n = 1:length(tmp2_th) % N10
    tmp2_th(n,1) = tmp2_th(n,1) + 180;
    if tmp2_th(n,1) > 360
        tmp2_th(n,1) = tmp2_th(n,1) - 360;
    end
end
for n = 1:length(tmp3_th) % E10
    tmp3_th(n,1) = tmp3_th(n,1) + 180;
    if tmp3_th(n,1) > 360
        tmp3_th(n,1) = tmp3_th(n,1) - 360;
    end
end
for n = 1:length(tmp4_th) % S10
    tmp4_th(n,1) = tmp4_th(n,1) + 180;
    if tmp4_th(n,1) > 360
        tmp4_th(n,1) = tmp4_th(n,1) - 360;
    end
end
for n = 1:length(tmp5_th) % W10
    tmp5_th(n,1) = tmp5_th(n,1) + 180;
    if tmp5_th(n,1) > 360
        tmp5_th(n,1) = tmp5_th(n,1) - 360;
    end
end

[MMx1,MMy1] = pol2cart(tmp1_th,tmp1_rho); % middle pnt
[MMx2,MMy2] = pol2cart(tmp2_th,tmp2_rho); % N10
[MMx3,MMy3] = pol2cart(tmp3_th,tmp3_rho); % E10
[MMx4,MMy4] = pol2cart(tmp4_th,tmp4_rho); % S10
[MMx5,MMy5] = pol2cart(tmp5_th,tmp5_rho); % W10

MMins1 = [MMx1,MMy1];
MM(:,2:3) = MMins1;
MMins2 = [MMx2,MMy2];
MMN10(:,2:3) = MMins2;
MMins3 = [MMx3,MMy3];
MME10(:,2:3) = MMins3;
MMins4 = [MMx4,MMy4];
MMS10(:,2:3) = MMins4;
MMins5 = [MMx5,MMy5];
MMW10(:,2:3) = MMins5;

%% CHOOSE DATES

% from = '08-Mar-1990 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
% to   = '10-Mar-1990 07:00:00'; % [dd-mm-yyyy hh:00:00]

% 2 r
% from = '08-Mar-1990 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
% to   = '08-Mar-1992 07:00:00'; % [dd-mm-yyyy hh:00:00]

% 5 r
% from = '08-Mar-1986 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
% to   = '08-Mar-1991 07:00:00'; % [dd-mm-yyyy hh:00:00]

% 10 r
from = '08-Mar-1985 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
to   = '08-Mar-1995 07:00:00'; % [dd-mm-yyyy hh:00:00]

% finding the index row for the specific to and from dates 
% LIK FOR ALLE!
IndexFrom = find(contains(MM,from));
IndexTo   = find(contains(MM,to));
rowF = IndexFrom;
rowT = IndexTo;

% Lage kjempematrise med xvel1 yvel1 xvel2 yvel2... -> ingen endring index

 % wind (column 5) and deeper current (< 100m) (column 16-22) 
 % wind (column 2) and deeper current (< 100m) (column 13-19) 
 

% TRAINING DATASET

a1 = 2:3;    %wind
a2 = 4:5;    %0m
a3 = 6:7;    %10m
a4 = 8:9;    %20m
a5 = 10:11;  %30m
a6 = 12:13;  %40m
a7 = 14:15;  %50m
a8 = 16:17;  %60m
a9 = 18:19;  %70m
a10 = 20:21; %80m
a11 = 22:23; %90m
a12 = 24:25; %100m
a13 = 26:27; %125m
a14 = 28:29; %150m
a15 = 30:31; %175m
a16 = 32:33; %200m
a17 = 34:35; %250m
a18 = 36:37; %300m

f1 = rowF:rowT;
f2 = rowF-1:rowT-1;
f3 = rowF-2:rowT-2;
f4 = rowF-3:rowT-3;
f5 = rowF-4:rowT-4;
f6 = rowF-5:rowT-5;
f7 = rowF-6:rowT-6;
f8 = rowF-7:rowT-7;


%%
% velger her hvor mye/hvilken data som skal vre med
f = {f1 f2 f3 f4 f5 f6 f7 f8};
a = {a1 a2 a3 a4};
% a = {a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18};
%    wind 0  10 20 30 40 50 60 70 80  90  100 125 150 175 200 250 300


%% t = X-elementer for 0-punkt

t = cell(1,length(f));
tIgjen = zeros(length(f1),2*length(a));
for j = 1:length(f)
    tn0_try = zeros(length(f1),length(a));
    tn0_try(:,1:2) = MM(f{j},a{1});
    for i = 2:length(a)
        tn0_try(:,2*i-1:2*i) = MM(f{j},a{i});
    end
    tn0_try = num2cell(tn0_try);
    t{j} = tn0_try(:,:);
end

tIgjen = [ t{1} t{2} t{3} t{4} t{5} t{6} t{7} t{8} ];
tIgjen = cell2mat(tIgjen);


%% tN10 = X-elementer for N10 punkt
tN10 = cell(1,length(f));
for j = 1:length(f)
    tn0_try = zeros(length(f1),length(a));
    tn0_try(:,1:2) = MMN10(f{j},a{1});
    for i = 2:length(a)
        tn0_try(:,2*i-1:2*i) = MMN10(f{j},a{i});
    end
    tn0_try = num2cell(tn0_try);
    tN10{j} = tn0_try(:,:);
end

tN10Igjen = [ tN10{1} tN10{2} tN10{3} tN10{4} tN10{5} tN10{6} tN10{7} tN10{8} ];
tN10Igjen = cell2mat(tN10Igjen);

%% tE10 = X-elementer for E10 punkt
tE10 = cell(1,length(f));
for j = 1:length(f)
    tn0_try = zeros(length(f1),length(a));
    tn0_try(:,1:2) = MME10(f{j},a{1});
    for i = 2:length(a)
        tn0_try(:,2*i-1:2*i) = MME10(f{j},a{i});
    end
    tn0_try = num2cell(tn0_try);
    tE10{j} = tn0_try(:,:);
end

tE10Igjen = [ tE10{1} tE10{2} tE10{3} tE10{4} tE10{5} tE10{6} tE10{7} tE10{8} ];
tE10Igjen = cell2mat(tE10Igjen);

%% tS10 = X-elementer for S10 punkt
tS10 = cell(1,length(f));
for j = 1:length(f)
    tn0_try = zeros(length(f1),length(a));
    tn0_try(:,1:2) = MMS10(f{j},a{1});
    for i = 2:length(a)
        tn0_try(:,2*i-1:2*i) = MMS10(f{j},a{i});
    end
    tn0_try = num2cell(tn0_try);
    tS10{j} = tn0_try(:,:);
end

tS10Igjen = [ tS10{1} tS10{2} tS10{3} tS10{4} tS10{5} tS10{6} tS10{7} tS10{8} ];
tS10Igjen = cell2mat(tS10Igjen);

%% tW10 = X-elementer for W10 punkt
tW10 = cell(1,length(f));
for j = 1:length(f)
    tn0_try = zeros(length(f1),length(a));
    tn0_try(:,1:2) = MMW10(f{j},a{1});
    for i = 2:length(a)
        tn0_try(:,2*i-1:2*i) = MMW10(f{j},a{i});
    end
    tn0_try = num2cell(tn0_try);
    tW10{j} = tn0_try(:,:);
end

tW10Igjen = [ tW10{1} tW10{2} tW10{3} tW10{4} tW10{5} tW10{6} tW10{7} tW10{8} ];
tW10Igjen = cell2mat(tW10Igjen);

% PUTTING TOGETHER TO X MATRIX
X = [tIgjen tN10Igjen tE10Igjen tS10Igjen tW10Igjen];

% RESPONSE IS WHAT HAPPENS RIGHT AFTER TRAINING..
diffFT = rowT - rowF;
g1 = (rowT+1):(rowT+diffFT+1);

% SETTING UP Y MATRIX AND WANT TO SET UP MUCH LESS RESPONSE THAN TRAIN

% OBS! Pass p tidsaspektet! rett etter dersom vil forecaste, samtidig for  relatere!
% t1 = [ MM(f1,a1) MM(f1,a2)  MM(f1,a3)  MM(f1,a4)  MM(f1,a5)  MM(f1,a6)  MM(f1,a7)  MM(f1,a8) ]; % tn FULL
t1 = [ MM(f1,a5)  MM(f1,a6)  MM(f1,a7)  MM(f1,a8)  MM(f1,a9)  MM(f1,a10)  MM(f1,a11) MM(f1,a12) MM(f1,a13) MM(f1,a14) MM(f1,a15) MM(f1,a16) MM(f1,a17) MM(f1,a18) ]; % tn FULL

Y = [ t1 ]; % response matrix
Y = str2double(Y);


%%

% TESTING DATASET
% (MAKING TEST SET THE DATA RIGHT AFTER RESPONSE SET - MAYBE A YEAR BETTER?)

h1 = g1+1;
h2 = h1-1;
h3 = h2-2;
h4 = h3-3;
h5 = h4-4;
h6 = h5-5;
h7 = h6-6;
h8 = h7-7;

h = {h1 h2 h3 h4 h5 h6 h7 h8};

% SETTING UP X-MATRICES FOR TESTING DATASET

tT0 = cell(1,length(h));
for j = 1:length(h)
    tnT0_try = zeros(length(h1),length(a));
    tnT0_try(:,1:2) = MM(h{j},a{1});
    for i = 2:length(a)
        tnT0_try(:,2*i-1:2*i) = MM(h{j},a{i});
    end
    tnT0_try = num2cell(tnT0_try);
    tT0{j} = tnT0_try(:,:);
end

tT0Igjen = [ tT0{1} tT0{2} tT0{3} tT0{4} tT0{5} tT0{6} tT0{7} tT0{8} ];
tT0Igjen = cell2mat(tT0Igjen);

tTN10 = cell(1,length(h));
for j = 1:length(h)
    tnTN10_try = zeros(length(h1),length(a));
    tnTN10_try(:,1:2) = MMN10(h{j},a{1});
    for i = 2:length(a)
        tnTN10_try(:,2*i-1:2*i) = MMN10(h{j},a{i});
    end
    tnTN10_try = num2cell(tnTN10_try);
    tTN10{j} = tnTN10_try(:,:);
end

tTN10Igjen = [ tTN10{1} tTN10{2} tTN10{3} tTN10{4} tTN10{5} tTN10{6} tTN10{7} tTN10{8} ];
tTN10Igjen = cell2mat(tTN10Igjen);

tTE10 = cell(1,length(h));
for j = 1:length(h)
    tnTE10_try = zeros(length(h1),length(a));
    tnTE10_try(:,1:2) = MME10(h{j},a{1});
    for i = 2:length(a)
        tnTE10_try(:,2*i-1:2*i) = MME10(h{j},a{i});
    end
    tnTE10_try = num2cell(tnTE10_try);
    tTE10{j} = tnTE10_try(:,:);
end

tTE10Igjen = [ tTE10{1} tTE10{2} tTE10{3} tTE10{4} tTE10{5} tTE10{6} tTE10{7} tTE10{8} ];
tTE10Igjen = cell2mat(tTE10Igjen);

tTS10 = cell(1,length(h));
for j = 1:length(h)
    tnTS10_try = zeros(length(h1),length(a));
    tnTS10_try(:,1:2) = MMS10(h{j},a{1});
    for i = 2:length(a)
        tnTS10_try(:,2*i-1:2*i) = MMS10(h{j},a{i});
    end
    tnTS10_try = num2cell(tnTS10_try);
    tTS10{j} = tnTS10_try(:,:);
end

tTS10Igjen = [ tTS10{1} tTS10{2} tTS10{3} tTS10{4} tTS10{5} tTS10{6} tTS10{7} tTS10{8} ];
tTS10Igjen = cell2mat(tTS10Igjen);

tTW10 = cell(1,length(h));
for j = 1:length(h)
    tnTW10_try = zeros(length(h1),length(a));
    tnTW10_try(:,1:2) = MMW10(h{j},a{1});
    for i = 2:length(a)
        tnTW10_try(:,2*i-1:2*i) = MMW10(h{j},a{i});
    end
    tnTW10_try = num2cell(tnTW10_try);
    tTW10{j} = tnTW10_try(:,:);
end

tTW10Igjen = [ tTW10{1} tTW10{2} tTW10{3} tTW10{4} tTW10{5} tTW10{6} tTW10{7} tTW10{8} ];
tTW10Igjen = cell2mat(tTW10Igjen);




% med vind
% tn_2  = [ MM(h1,a1) MM(h1,a2)  MM(h1,a3)  MM(h1,a4)  MM(h1,a5)  MM(h1,a6)  MM(h1,a7)  MM(h1,a8) ]; % tn
% tn1_2 =  [ MM(h2,a1) MM(h2,a2)  MM(h2,a3)  MM(h2,a4)  MM(h2,a5)  MM(h2,a6)  MM(h2,a7)  MM(h2,a8) ]; % tn-1
% tn2_2 =   [ MM(h3,a1) MM(h3,a2)  MM(h3,a3)  MM(h3,a4)  MM(h3,a5)  MM(h3,a6)  MM(h3,a7)  MM(h3,a8) ]; % tn-2
% tn3_2 =    [ MM(h4,a1) MM(h4,a2)  MM(h4,a3)  MM(h4,a4)  MM(h4,a5)  MM(h4,a6)  MM(h4,a7)  MM(h4,a8) ]; % tn-3
% tn4_2 =     [ MM(h5,a1) MM(h5,a2)  MM(h5,a3)  MM(h5,a4)  MM(h5,a5)  MM(h5,a6)  MM(h5,a7)  MM(h5,a8) ]; % tn-4
% tn5_2 =      [ MM(h6,a1) MM(h6,a2)  MM(h6,a3)  MM(h6,a4)  MM(h6,a5)  MM(h6,a6)  MM(h6,a7)  MM(h6,a8) ]; % tn-5
% tn6_2 =       [ MM(h7,a1) MM(h7,a2)  MM(h7,a3)  MM(h7,a4)  MM(h7,a5)  MM(h7,a6)  MM(h7,a7)  MM(h7,a8) ]; % tn-6
% tn7_2 =        [ MM(h8,a1) MM(h8,a2)  MM(h8,a3)  MM(h8,a4)  MM(h8,a5)  MM(h8,a6)  MM(h8,a7)  MM(h8,a8) ]; % tn-7

% uten vind
% tn_2  = [ MM(h1,a2)  MM(h1,a3)  MM(h1,a4)  MM(h1,a5)  MM(h1,a6)  MM(h1,a7)  MM(h1,a8) ]; % tn
% tn1_2 =  [ MM(h2,a2)  MM(h2,a3)  MM(h2,a4)  MM(h2,a5)  MM(h2,a6)  MM(h2,a7)  MM(h2,a8) ]; % tn-1
% tn2_2 =   [ MM(h3,a2)  MM(h3,a3)  MM(h3,a4)  MM(h3,a5)  MM(h3,a6)  MM(h3,a7)  MM(h3,a8) ]; % tn-2
% tn3_2 =    [ MM(h4,a2)  MM(h4,a3)  MM(h4,a4)  MM(h4,a5)  MM(h4,a6)  MM(h4,a7)  MM(h4,a8) ]; % tn-3
% tn4_2 =     [ MM(h5,a2)  MM(h5,a3)  MM(h5,a4)  MM(h5,a5)  MM(h5,a6)  MM(h5,a7)  MM(h5,a8) ]; % tn-4
% tn5_2 =      [ MM(h6,a2)  MM(h6,a3)  MM(h6,a4)  MM(h6,a5)  MM(h6,a6)  MM(h6,a7)  MM(h6,a8) ]; % tn-5
% tn6_2 =       [ MM(h7,a2)  MM(h7,a3)  MM(h7,a4)  MM(h7,a5)  MM(h7,a6)  MM(h7,a7)  MM(h7,a8) ]; % tn-6
% tn7_2 =        [ MM(h8,a2)  MM(h8,a3)  MM(h8,a4)  MM(h8,a5)  MM(h8,a6)  MM(h8,a7)  MM(h8,a8) ]; % tn-7


% PUTTING TOGETHER TO X MATRIX
X2 = [tT0Igjen tTN10Igjen tTE10Igjen tTS10Igjen tTW10Igjen];

% X2 = [ tn_2 tn1_2 tn2_2 tn3_2 tn4_2 tn5_2 tn6_2 tn7_2 ]; % predictor matrix
% X2 = str2double(X2);

%diffFT = rowT - rowF;
%g1 = (rowT+1):(rowT+diffFT+1);
% g2 = rowF-1:rowT-1; g1-1;
% g3 = rowF-2:rowT-2;
% g4 = rowF-3:rowT-3;
% g5 = rowF-4:rowT-4;
% g6 = rowF-5:rowT-5;
% g7 = rowF-6:rowT-6;
% g8 = rowF-7:rowT-7;

% t1 = [ MM(f1,a1) MM(f1,a2)  MM(f1,a3)  MM(f1,a4)  MM(f1,a5)  MM(f1,a6)  MM(f1,a7)  MM(f1,a8) ]; % tn FULL

%        100m xy  -  125 xy  -  150 xy  -  175 xy  -  200 xy  -  250 xy  -  300 xy
t1_2 = [ MM(h1,a5)  MM(h1,a6)  MM(h1,a7)  MM(h1,a8) MM(h1,a9)  MM(h1,a10)  MM(h1,a11) MM(h1,a12)  MM(h1,a13)  MM(h1,a14) MM(h1,a15)  MM(h1,a16)  MM(h1,a17) MM(h1,a18) ]; % tn FULL

Y2 = [ t1_2 ]; % response matrix
Y2 = str2double(Y2);





%% PLSR analysis

% PARTIAL LEAST SQUARES REGRESSION

ncomp = 4; % 4 32
time  = linspace(1,1000,1000);
%components = 1:16;

% TRAINING THE ALGORITHM
[XL,YL,XS,YS,BETA,PCTvar,MSE,stats] = plsregress(X,Y,ncomp);

[n,p] = size(X);

yFit_train = [ones(n,1) X]*BETA; 

diff_train = Y - yFit_train; % blir residuals..?


% TESTING THE BETA on test set
[~,widthX2] = size(X2); %s lenge det er de frste elementene!! (og X/X2 ikke er like store)
yFit_test = [ones(n,1) X2]*BETA(1:(widthX2+1),:);


%% UN-NORMALIZE (AND UN-SCALE) THE DATA...

load strdDevC.mat
load strdDevW.mat

% strength ganges med standard deviation
strdDevCcart = repelem(strdDevC,1,2);
strdDevWcart = repelem(strdDevW,1,2);

strdDevcart = [ strdDevWcart strdDevCcart ];
strdDevpol  = [ strdDevW strdDevC ];

yFit_train2 = yFit_train.*strdDevcart(:,9:end);
yFit_train = yFit_train2;

yFit_test2 = yFit_test.*strdDevcart(:,9:end);
yFit_test = yFit_test2;

Y_try = Y.*strdDevcart(:,9:end);
Y = Y_try;

Y_try2 = Y2.*strdDevcart(:,9:end);
Y2 = Y_try2;


%% plotting
set(0,'defaultAxesFontSize',14)
set(0,'DefaultLineLineWidth',1.5);
set(0,'DefaultAxesXGrid','on','DefaultAxesYGrid','on');
set(0,'DefaultLineMarkerSize',8);
% set(0,'DefaultAxesMarkerSize',8);


[rowY,colY] = size(Y);

% figure
% plot(1:colY,yFit_train,1:colY,yFit_test);
% legend('xvelTrain','yvelTrain','xvelTest','yvelTest')
% title('Fitted x- and y-velocities for training set and testing set')

% figure
% plot(1:colY,sum(yFit_train)/rowY,'.',1:colY,sum(yFit_test)/rowY,'.','MarkerSize',12); % RGB ,'Color',[.8 .2 0]
% legend('xy-Train','xy-Test','Location','Best')
% title('Fitted SUM/rows of x- and y-velocities for training set and testing set')
% % ser at det er liten total forskjell p hver enkelt av dem
% xticks([1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28])
% %xticklabels({'x100','y100','x125','y125','x150','y150','x175','y175','x200','y200','x250','y250','x300','y300'})
% xticklabels({'30x','30y','40x','40y','50x','50y','60x','60y','70x','70y','80x','80y', ...
%     '90x','90y','100x','100y','125x','125y','150x','150y','175x','175y','200x','200y','250x','250y','300x','300y'})
% xlabel('depth [m]')

%%
figure
qe1 = sum(yFit_train)/rowY;
qe1x = qe1(1:2:end);
qe1y = qe1(2:2:end);
qe2 = sum(yFit_test)/rowY;
qe2x = qe2(1:2:end);
qe2y = qe2(2:2:end);

% plot(1:(colY/2),qe1x/rowY,'.-',1:(colY/2),qe1y/rowY,'.-',1:(colY/2),qe2x/rowY,'.-',1:(colY/2),qe2y/rowY,'.-','MarkerSize',12); % RGB ,'Color',[.8 .2 0]
% legend('x-Train','y-Train','x-Test','y-Test','Location','E')
% title('Fitted SUM/rows of x- and y-velocities for training set and testing set')
% % ser at det er liten total forskjell p hver enkelt av dem
% % xticks([1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 2021 22 23 24 25 26 27 28])
% % xticklabels({'30x','30y','40x','40y','50x','50y','60x','60y','70x','70y','80x','80y', ...
% %     '90x','90y','100x','100y','125x','125y','150x','150y','175x','175y','200x','200y','250x','250y','300x','300y'})
% xticks([1 2 3 4 5 6 7 8 9 10 11 12 13 14])
% xticklabels({'30','40','50','60','70','80','90','100','125','150','175','200','250','300'})
% xlabel('depth [m]')


%% CALCULATING THE ERROR

% error = sum((yFit_test - yFit_train).^2)/(rowY-1);
error_tr2E4nc = sum((Y - yFit_train).^2)/(rowY-1);
error_te2E4nc = sum((Y2 - yFit_test).^2)/(rowY-1);
% error_te10 = sum((Y2 - yFit_test).^2)/(rowY-1);
% errorx_tr10 = error_tr10E4nc(1:2:end);
% errory_tr10 = error_tr10E4nc(2:2:end);
% errorx_te10 = error_te10E4nc(1:2:end);
% errory_te10 = error_te10E4nc(2:2:end);
% 
% load error_tr5.mat
% load error_te5.mat
% errorx_tr5 = error_tr5E4nc(1:2:end);
% errory_tr5 = error_tr5E4nc(2:2:end);
% errorx_te5 = error_te5E4nc(1:2:end);
% errory_te5 = error_te5E4nc(2:2:end);
% 
% load error_tr2.mat
% load error_te2.mat
% errorx_tr2 = error_tr2E4nc(1:2:end);
% errory_tr2 = error_tr2E4nc(2:2:end);
% errorx_te2 = error_te2E4nc(1:2:end);
% errory_te2 = error_te2E4nc(2:2:end);
%%
bla = (Y2 - yFit_test).^2;

clf;
figure;
imagesc(bla(1:100,:));     %displays image with scaled colors (uses full colormap)
axis square
xticks([1 3 5 7 9 11 13 15 17 19 21 23 25 27]);
xticklabels({'30','40','50','60','70','80','90','100','125','150','175','200','250','300'});
xlabel('Variables')
yticklabels({});
ylabel('Arbitrary observations')
title('Error magnitude in the matrix')
colorbar
figure;
imagesc(bla(1001:1100,:));     %displays image with scaled colors (uses full colormap)
axis square
xticks([1 3 5 7 9 11 13 15 17 19 21 23 25 27]);
xticklabels({'30','40','50','60','70','80','90','100','125','150','175','200','250','300'});
xlabel('Variables')
yticklabels({});
ylabel('Arbitrary observations')
title('Error magnitude in the matrix')
colorbar
figure;
imagesc(bla(10000:10100,:));     %displays image with scaled colors (uses full colormap)
axis square
xticks([1 3 5 7 9 11 13 15 17 19 21 23 25 27]);
xticklabels({'30','40','50','60','70','80','90','100','125','150','175','200','250','300'});
xlabel('Variables')
yticklabels({});
ylabel('Arbitrary observations')
title('Error magnitude in the matrix')
colorbar

%%
% figure
% plot(1:colY/2,errorx_tr5,'.-',1:colY/2,errory_tr5,'.-'); hold on;
% plot(1:colY/2,errorx_tr10,'.-',1:colY/2,errory_tr10,'.-');
%% Etter fix... alts uten treningsdata-error
figure
subplot(2,1,1)
% plot(1:colY/2,error_te2(1:2:end),'.-'); hold on;
% plot(1:colY/2,error_te5(1:2:end),'.-'); hold on;
% plot(1:colY/2,error_te10(1:2:end),'.-');
plot(1:colY/2,error_te2E4nc(1:2:end),'.-'); hold on;
plot(1:colY/2,error_te5E4nc(1:2:end),'.-'); hold on;
plot(1:colY/2,error_te10E4nc(1:2:end),'.-');
l = legend('2years','5years','10years','Location','NW');
l = set(l,'FontSize',15);
title('MSE of x-velocities for test sets rank 4')
xticks([1 2 3 4 5 6 7 8 9 10 11 12 13 14])
xticklabels({'30m','40m','50m','60m','70m','80m','90m','100m','125m','150m','175m','200m','250m','300m'})
xlabel('Estimated variables')
ylabel('Mean squared sum error')
axis([0 14 0 2])

subplot(2,1,2)
% plot(1:colY/2,error_te2(2:2:end),'.-'); hold on;
% plot(1:colY/2,error_te5(2:2:end),'.-'); hold on;
% plot(1:colY/2,error_te10(2:2:end),'.-');
plot(1:colY/2,error_te2E4nc(2:2:end),'.-'); hold on;
plot(1:colY/2,error_te5E4nc(2:2:end),'.-'); hold on;
plot(1:colY/2,error_te10E4nc(2:2:end),'.-');
title('MSE of y-velocities for test set rank 4')
xticks([1 2 3 4 5 6 7 8 9 10 11 12 13 14])
xticklabels({'30m','40m','50m','60m','70m','80m','90m','100m','125m','150m','175m','200m','250m','300m'})
xlabel('Estimated variables')
ylabel('Mean squared sum error')
axis([0 14 0 2])

%%
% figure
% subplot(2,1,1)
% %plot(1:ncomp,error);
% plot(1:colY/2,errorx_tr2,'.-',1:colY/2,errory_tr2,'.-'); hold on;
% plot(1:colY/2,errorx_tr5,'.-',1:colY/2,errory_tr5,'.-'); hold on;
% plot(1:colY/2,errorx_tr10,'.-',1:colY/2,errory_tr10,'.-');
% legend('x error 2y','y error 2y','x error 5y','y error 5y','x error 10y','y error 10y','Location','NW')
% title('MSE of x-and y-velocities for train set')
% xticks([1 2 3 4 5 6 7 8 9 10 11 12 13 14])
% xticklabels({'30m','40m','50m','60m','70m','80m','90m','100m','125m','150m','175m','200m','250m','300m'})
% xlabel('Estimated variables')
% ylabel('Mean squared sum error')
% 
% subplot(2,1,2)
% plot(1:colY/2,errorx_te2,'.-',1:colY/2,errory_te2,'.-'); hold on;
% plot(1:colY/2,errorx_te5,'.-',1:colY/2,errory_te5,'.-'); hold on;
% plot(1:colY/2,errorx_te10,'.-',1:colY/2,errory_te10,'.-');
% legend('x error 2y','y error 2y','x error 5y','y error 5y','x error 10y','y error 10y','Location','NW')
% title('MSE of x-and y-velocities for test set')
% xticks([1 2 3 4 5 6 7 8 9 10 11 12 13 14])
% xticklabels({'30m','40m','50m','60m','70m','80m','90m','100m','125m','150m','175m','200m','250m','300m'})
% xlabel('Estimated variables')
% ylabel('Mean squared sum error')

% larger error for deeper currents!

%%
% PLOTTING CUMULATIVE VARIANCE EXPLAINED IN Y

% figure
% plot(1:ncomp,cumsum(100*PCTvar(2,:)),'-bo');
% xlabel('Number of components used')
% ylabel('Cumulative percent')
% title('Variance explained in Y depending on number of components used (2 years)')
% axis([1 ncomp 0 100]);


%% PLOTTING Y-MATRICES VS yFIT MATRICES


% PLOTTING X AND Y SEPARATED
yFit_x_train = yFit_train(:,1:2:end);
yFit_y_train = yFit_train(:,2:2:end);
Y_x = Y(:,1:2:end);
Y_y = Y(:,2:2:end);

yFit_x_test = yFit_test(:,1:2:end);
yFit_y_test = yFit_test(:,2:2:end);
Y2_x = Y2(:,1:2:end);
Y2_y = Y2(:,2:2:end);


% figure
% plot(Y',yFit_train','.',Y2',yFit_test','.','MarkerSize',14); hold on;
% % legend('xvelTrain','yvelTrain','xvelTest','yvelTest','Location','SE')
% legend('x100','y100','x125','y125','x150','y150','x175','y175','x200','y200','x250','y250','x300','y300','Location','SE')
% title(['Y train and Y test vs yFit train and yFit test with ncomp = ',num2str(ncomp)]);

% PLOT X-VEL IN FITTED Y VS ORIGINAL Y TEST AND TRAIN
% figure
% plot(Y_x',yFit_x_train','.',Y2_x',yFit_x_test','.','MarkerSize',14); hold on;
% legend('30','40','50','60','70','80','90','100','125','150','175','200','250','300','Location','SE')
% title(['X vel: train and test yFit comp. with Y using ncomp = ',num2str(ncomp)]);
%   % grey linear line in the background
% x = linspace(-1,1,10);
% y = x;
% plot(x,y,'--','Color',[.5 .5 .5]')
% grid on
% xlabel('Y')
% ylabel('YFit')


% % LAST COMMENTED
% figure
% plot(Y_x(:,1:7)',yFit_x_train(:,1:7)','.',Y2_x(:,1:7)',yFit_x_test(:,1:7)','.','MarkerSize',14); hold on;
% legend('30','40','50','60','70','80','90','Location','SE')
% title(['X vel: train and test yFit comp. with Y using ncomp = ',num2str(ncomp)]);
%   % grey linear line in the background
% x = linspace(-1,1,10);
% y = x;
% plot(x,y,'--','Color',[.5 .5 .5]')
% grid on
% xlabel('Y')
% ylabel('YFit')
% 
% 
% figure
% plot(Y_x(:,8:end)',yFit_x_train(:,8:end)','.',Y2_x(:,8:end)',yFit_x_test(:,8:end)','.','MarkerSize',14); hold on;
% legend('100','125','150','175','200','250','300','Location','SE')
% title(['X vel: train and test yFit comp. with Y using ncomp = ',num2str(ncomp)]);
%   % grey linear line in the background
% x = linspace(-1,1,10);
% y = x;
% plot(x,y,'--','Color',[.5 .5 .5]')
% grid on
% xlabel('Y')
% ylabel('YFit')
% %


% PLOT Y-VEL IN FITTED Y VS ORIGINAL Y TEST AND TRAIN
% figure
% plot(Y_y',yFit_y_train','.',Y2_y',yFit_y_test','.','MarkerSize',14); hold on;
% legend('30','40','50','60','70','80','90','100','125','150','175','200','250','300','Location','SE')
% title(['Y vel: train and test yFit comp. with Y using ncomp = ',num2str(ncomp)]);
%   % grey linear line in the background
% x = linspace(-1,1,10);
% y = x;
% plot(x,y,'--','Color',[.5 .5 .5]')
% grid on
% xlabel('Y')
% ylabel('YFit')

% % LAST COMMENTED
% figure
% plot(Y_y(:,1:7)',yFit_y_train(:,1:7)','.',Y2_y(:,1:7)',yFit_y_test(:,1:7)','.','MarkerSize',14); hold on;
% legend('30','40','50','60','70','80','90','Location','SE')
% title(['Y vel: train and test yFit comp. with Y using ncomp = ',num2str(ncomp)]);
%   % grey linear line in the background
% x = linspace(-1,1,10);
% y = x;
% plot(x,y,'--','Color',[.5 .5 .5]')
% grid on
% xlabel('Y')
% ylabel('YFit')
% 
% 
% figure
% plot(Y_y(:,8:end)',yFit_y_train(:,8:end)','.',Y2_y(:,8:end)',yFit_y_test(:,8:end)','.','MarkerSize',14); hold on;
% legend('100','125','150','175','200','250','300','Location','SE')
% title(['Y vel: train and test yFit comp. with Y using ncomp = ',num2str(ncomp)]);
%   % grey linear line in the background
% x = linspace(-1,1,10);
% y = x;
% plot(x,y,'--','Color',[.5 .5 .5]')
% grid on
% xlabel('Y')
% ylabel('YFit')
% %


%% SEPARATING TRAINING AND TESTING SET TO LOOK AT DIFFERENCES

% % LAST COMMENTED
% figure
% % plot(Y_x(:,1:7)',yFit_x_train(:,1:7)','.','MarkerSize',14); hold on;
% % legend('30','40','50','60','70','80','90','Location','SE')
% % plot(Y_x(:,8:14)',yFit_x_train(:,8:14)','.','MarkerSize',14); hold on;
% % legend('100','125','150','175','200','250','300','Location','SE')
% 
% % plot(Y_y(:,1:7)',yFit_y_train(:,1:7)','.','MarkerSize',14); hold on;
% % legend('30','40','50','60','70','80','90','Location','SE')
% plot(Y_y(:,8:14)',yFit_y_train(:,8:14)','.','MarkerSize',14); hold on;
% legend('100','125','150','175','200','250','300','Location','SE')
% 
% title(['X vel: train yFit comp. with Y using ncomp = ',num2str(ncomp)]);
%   % grey linear line in the background
% x = linspace(-1,1,10);
% y = x;
% plot(x,y,'--','Color',[.5 .5 .5]')
% grid on
% xlabel('Y')
% ylabel('YFit')
% 
% 
% figure
% % plot(Y2_x(:,1:7)',yFit_x_test(:,1:7)','.','MarkerSize',14); hold on;
% % legend('30','40','50','60','70','80','90','Location','SE')
% % plot(Y2_x(:,8:14)',yFit_x_test(:,8:14)','.','MarkerSize',14); hold on;
% % legend('100','125','150','175','200','250','300','Location','SE')
% 
% % plot(Y2_y(:,1:7)',yFit_y_test(:,1:7)','.','MarkerSize',14); hold on;
% % legend('30','40','50','60','70','80','90','Location','SE')
% plot(Y2_y(:,8:14)',yFit_y_test(:,8:14)','.','MarkerSize',14); hold on;
% legend('100','125','150','175','200','250','300','Location','SE')
% 
% title(['X vel: test yFit comp. with Y using ncomp = ',num2str(ncomp)]);
%   % grey linear line in the background
% x = linspace(-1,1,10);
% y = x;
% plot(x,y,'--','Color',[.5 .5 .5]')
% grid on
% xlabel('Y')
% ylabel('YFit')
% %


%%
% figure
% kl = 18;
% plot(Y(:,kl)',yFit_train(:,kl)','.',Y2(:,kl)',yFit_test(:,kl)','.','MarkerSize',10);
% xlabel('Y')
% ylabel('YFit')


%% RECONTRUCTING yFit INTO TIMESERIES TO SEE DIFFERNCE IN CURRENT

% back to polar coordinates from cartesian
% TH: (wind/current) direction, 
%  R: (wind/current) strength

[TH_train,R_train] = cart2pol(Y_x,Y_y);
[TH_trainFit,R_trainFit] = cart2pol(yFit_x_train,yFit_y_train);
[TH_test,R_test] = cart2pol(Y2_x,Y2_y);
[TH_testFit,R_testFit] = cart2pol(yFit_x_test,yFit_y_test);

%%
% strength
time2 = linspace(1,n,n);
omr = 1401:1500;%1201:1300;%5001:5200;%8000:8500;
% Samme som for 1000pnts PLSR og GPR
% plot(time2(omr),R_test(omr,13:14),'b',time2(omr),R_testFit(omr,13:14),'m')

figure
subplot(4,1,1)
% plot(omr,R_test(omr,2),'b--',omr,R_testFit(omr,2),'b',omr,R_test(omr,1),'r--',omr,R_testFit(omr,1),'r');
plot(omr,Y2_y(omr,1),'b--',omr,yFit_y_test(omr,1),'b',omr,Y2_x(omr,1),'m--',omr,yFit_x_test(omr,1),'m');
title('x- and y-velocity at 30m estimated and real')
l = legend('y-vel real','y-vel est','x-vel real','x-vel est');
l = set(l,'FontSize',15);
xlabel('Time [h]')
ylabel('C_s [cm/s]')

subplot(4,1,2)
plot(omr,Y2_y(omr,6),'b--',omr,yFit_y_test(omr,6),'b',omr,Y2_x(omr,6),'m--',omr,yFit_x_test(omr,6),'m');
title('x- and y-velocity at 80m estimated and real')
xlabel('Time [h]')
ylabel('C_s [cm/s]')

subplot(4,1,3)
plot(omr,Y2_y(omr,10),'b--',omr,yFit_y_test(omr,10),'b',omr,Y2_x(omr,10),'m--',omr,yFit_x_test(omr,10),'m');
title('x- and y-velocity at 150m estimated and real')
xlabel('Time [h]')
ylabel('C_s [cm/s]')

subplot(4,1,4)
plot(omr,Y2_y(omr,14),'b--',omr,yFit_y_test(omr,14),'b',omr,Y2_x(omr,14),'m--',omr,yFit_x_test(omr,14),'m');
title('x- and y-velocity at 300m estimated and real')
xlabel('Time [h]')
ylabel('C_s [cm/s]')

% first try TS..
% figure
% subplot(2,1,1)
% plot(time2(omr),R_train(omr,1:7),'b',time2(omr),R_trainFit(omr,1:7),'m')
% xlabel('time')
% ylabel('Current strength')
% title('Trained and fitted current strength 30m:90m')
% axis([omr(1) omr(end) 0 7])
% 
% subplot(2,1,2)
% plot(time2(omr),R_train(omr,8:14),'b',time2(omr),R_trainFit(omr,8:14),'m')
% xlabel('time')
% ylabel('Current strength')
% title('Trained and fitted current strength 100m:300m')
% axis([omr(1) omr(end) 0 7])
% 
% figure
% subplot(2,1,1)
% plot(time2(omr),R_train(omr,1:7),'b',time2(omr),R_trainFit(omr,1:14),'m')
% xlabel('time')
% ylabel('Current strength')
% title('Test and fitted current strength 30m:90m')
% axis([omr(1) omr(end) 0 7])
% 
% subplot(2,1,2)
% plot(time2(omr),R_train(omr,8:14),'b',time2(omr),R_trainFit(omr,8:14),'m')
% xlabel('time')
% ylabel('Current strength')
% title('Test and fitted current strength 100m:300m')
% axis([omr(1) omr(end) 0 7])

%% Time series of current strength train and trainFit on different depths
%%%%%%%
% figure
% subplot(4,2,1)
% TS1 = plot(time2(omr),R_train(omr,1),'b'); hold on;
% plot(time2(omr),R_train(omr,2),'b');
% TS2 = plot(time2(omr),R_trainFit(omr,1),'m');
% plot(time2(omr),R_trainFit(omr,2),'m');
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Trained and fitted at 30m to 40m')
% axis([omr(1) omr(end) 0 5.5])
% 
% subplot(4,2,2)
% plot(time2(omr),R_train(omr,3:4),'b',time2(omr),R_trainFit(omr,3:4),'m')
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Trained and fitted at 50m to 60m')
% axis([omr(1) omr(end) 0 5.5])
% 
% subplot(4,2,3)
% plot(time2(omr),R_train(omr,5:6),'b',time2(omr),R_trainFit(omr,5:6),'m')
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Trained and fitted at 70m to 80m')
% axis([omr(1) omr(end) 0 5.5])
% 
% subplot(4,2,4)
% plot(time2(omr),R_train(omr,7:8),'b',time2(omr),R_trainFit(omr,7:8),'m')
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Trained and fitted at 90m to 100m')
% axis([omr(1) omr(end) 0 5.5])
% 
% subplot(4,2,5)
% plot(time2(omr),R_train(omr,9:10),'b',time2(omr),R_trainFit(omr,9:10),'m')
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Trained and fitted at 125m to 150m')
% axis([omr(1) omr(end) 0 5.5])
% 
% subplot(4,2,6)
% plot(time2(omr),R_train(omr,11:12),'b',time2(omr),R_trainFit(omr,11:12),'m')
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Trained and fitted at 175m to 200m')
% axis([omr(1) omr(end) 0 5.5])
% 
% subplot(4,2,7)
% plot(time2(omr),R_train(omr,13:14),'b',time2(omr),R_trainFit(omr,13:14),'m')
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Trained and fitted at  250m to 300m')
% axis([omr(1) omr(end) 0 5.5])
% 
% subplot(4,2,8)
% plot(0,0,0,0,0,0);
% axis off
% lgnd = legend([TS1 TS2],{'Train','TrainFit'}); % lgnd =
% newPos = [.7 .15 .09 .11];
% set(lgnd,'Position',newPos);
% lagret som: TS_Cs_trainAndTrainFit_2y.png , axis: axis([omr(1) omr(end) 0 7])
% lagret som: TS_Cs_trainAndTrainFit_10y.png , axis([omr(1) omr(end) 0 4.2])
% lagret som: TS_Cs_trainAndTrainFit_5y.png , axis([omr(1) omr(end) 0 5.5])

% Time series of current strength test and testFit on different depths (as used first time)
% figure
% subplot(4,2,1)
% TS1 = plot(time2(omr),R_test(omr,1),'b'); hold on;
% plot(time2(omr),R_test(omr,2),'b');
% TS2 = plot(time2(omr),R_testFit(omr,1),'m');
% plot(time2(omr),R_testFit(omr,2),'m');
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Tested and fitted at 30m to 40m')
% axis([omr(1) omr(end) 0 4.5])
% subplot(4,2,2)
% plot(time2(omr),R_test(omr,3:4),'b',time2(omr),R_testFit(omr,3:4),'m')
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Tested and fitted at 50m to 60m')
% axis([omr(1) omr(end) 0 4.5])
% subplot(4,2,3)
% plot(time2(omr),R_test(omr,5:6),'b',time2(omr),R_testFit(omr,5:6),'m')
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Tested and fitted at 70m to 80m')
% axis([omr(1) omr(end) 0 4.5])
% subplot(4,2,4)
% plot(time2(omr),R_test(omr,7:8),'b',time2(omr),R_testFit(omr,7:8),'m')
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Tested and fitted at 90m to 100m')
% axis([omr(1) omr(end) 0 4.5])
% subplot(4,2,5)
% plot(time2(omr),R_test(omr,9:10),'b',time2(omr),R_testFit(omr,9:10),'m')
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Tested and fitted at 125m to 150m')
% axis([omr(1) omr(end) 0 4.5])
% subplot(4,2,6)
% plot(time2(omr),R_test(omr,11:12),'b',time2(omr),R_testFit(omr,11:12),'m')
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Tested and fitted at 175m to 200m')
% axis([omr(1) omr(end) 0 4.5])
% subplot(4,2,7)
% plot(time2(omr),R_test(omr,13:14),'b',time2(omr),R_testFit(omr,13:14),'m')
% xlabel('Time [h]')
% ylabel('Cs [cm/s]')
% title('Tested and fitted at 250m to 300m')
% axis([omr(1) omr(end) 0 4.5])
% subplot(4,2,8)
% plot(0,0,0,0,0,0);
% axis off
% lgnd = legend([TS1 TS2],{'Test','TestFit'}); % lgnd =
% newPos = [.7 .15 .09 .11];
% set(lgnd,'Position',newPos);
% lagret som: TS_Cs_testAndTestFit_2y.png , axis: axis([omr(1) omr(end) 0 4.2])
% lagret som: TS_Cs_testAndTestFit_10y.png , axis: axis([omr(1) omr(end) 0 3.5])
% lagret som: TS_Cs_testAndTestFit_5y.png , axis: axis([omr(1) omr(end) 0 4.5])

%%

% figure
% polhist1 = polarhistogram(TH_train(:,1),12); hold on;
% polhist2 = polarhistogram(TH_train(:,14),12);
% polhist1.DisplayStyle = 'stairs';
% polhist2.DisplayStyle = 'stairs';
% polhist1.LineWidth = 5;
% polhist2.LineWidth = 4;
% polhist1.DisplayName = 'training set at 30 m';
% polhist2.DisplayName = 'training set at 300 m';
% legend
% title('Current directions of training set')
% 
% hold on; polhist3 = polarhistogram(TH_trainFit(:,1),12);
% polhist3.DisplayName = 'fitted training set at 30 m';
% 
% figure
% polhist1 = polarhistogram(TH_test(:,1),12); hold on;
% polhist2 = polarhistogram(TH_test(:,14),12);
% polhist1.DisplayStyle = 'stairs';
% polhist2.DisplayStyle = 'stairs';
% polhist1.LineWidth = 5;
% polhist2.LineWidth = 4;
% polhist1.DisplayName = 'testing set at 30 m';
% polhist2.DisplayName = 'testing set at 300 m';
% legend
% title('Current directions of testing set')
% 
% hold on; polhist3 = polarhistogram(TH_trainFit(:,1),12);
% polhist3.DisplayName = 'fitted testing set at 30 m';
% 
% figure
% polhist1 = polarhistogram(TH_test(:,10),12); hold on;
% polhist2 = polarhistogram(TH_test(:,14),12);
% polhist1.DisplayStyle = 'stairs';
% polhist2.DisplayStyle = 'stairs';
% polhist1.LineWidth = 5;
% polhist2.LineWidth = 4;
% polhist1.DisplayName = 'testing set at 150 m';
% polhist2.DisplayName = 'testing set at 300 m';
% legend
% title('Current directions of testing set')
% 
% hold on; polhist3 = polarhistogram(TH_trainFit(:,10),12);
% polhist3.DisplayName = 'fitted testing set at 150 m';





%%
% % figure
% % subplot(2,2,1)
% % polhist1 = polarhistogram(TH_train(:,1),12); hold on;
% % polhist2 = polarhistogram(TH_train(:,14),12);
% % polhist1.DisplayStyle = 'stairs';
% % polhist2.DisplayStyle = 'stairs';
% % polhist1.LineWidth = 5;
% % polhist2.LineWidth = 4;
% % polhist1.DisplayName = 'training set at 30 m';
% % polhist2.DisplayName = 'training set at 300 m';
% % %legend
% % title('Cd of training set and fit at 30m')
% % 
% % hold on; polhist3 = polarhistogram(TH_trainFit(:,1),12);
% % polhist3.DisplayName = 'fitted training set';
% % 
% % subplot(2,2,2)
% % polhist1 = polarhistogram(TH_train(:,1),12); hold on;
% % polhist2 = polarhistogram(TH_train(:,14),12);
% % polhist1.DisplayStyle = 'stairs';
% % polhist2.DisplayStyle = 'stairs';
% % polhist1.LineWidth = 5;
% % polhist2.LineWidth = 4;
% % polhist1.DisplayName = 'training set at 30 m';
% % polhist2.DisplayName = 'training set at 300 m';
% % legend
% % title('Cd of training set and fit at 300m')
% % 
% % hold on; polhist3 = polarhistogram(TH_trainFit(:,14),12);
% % polhist3.DisplayName = 'fitted training set';
% % 
% % subplot(2,2,3)
% % polhist1 = polarhistogram(TH_test(:,1),12); hold on;
% % polhist2 = polarhistogram(TH_test(:,14),12);
% % polhist1.DisplayStyle = 'stairs';
% % polhist2.DisplayStyle = 'stairs';
% % polhist1.LineWidth = 5;
% % polhist2.LineWidth = 4;
% % polhist1.DisplayName = 'testing set at 30 m';
% % polhist2.DisplayName = 'testing set at 300 m';
% % %legend
% % title('Cd of testing set and fit at 30m')
% % 
% % hold on; polhist3 = polarhistogram(TH_trainFit(:,1),12);
% % polhist3.DisplayName = 'fitted testing set';
% % 
% % subplot(2,2,4)
% % polhist1 = polarhistogram(TH_test(:,1),12); hold on;
% % polhist2 = polarhistogram(TH_test(:,14),12);
% % polhist1.DisplayStyle = 'stairs';
% % polhist2.DisplayStyle = 'stairs';
% % polhist1.LineWidth = 5;
% % polhist2.LineWidth = 4;
% % polhist1.DisplayName = 'testing set at 30 m';
% % polhist2.DisplayName = 'testing set at 300 m';
% % legend
% % title('Cd testing set and fit at 300m')
% % 
% % hold on; polhist3 = polarhistogram(TH_trainFit(:,14),12);
% % polhist3.DisplayName = 'fitted testing set';

% lagret som: Cd2y.png
% lagret som: Cd10y.png

%%
% figure
% polarhistogram(TH_trainFit(:,1),12)


% MSEx = sum(errorx)/length(errorx);
% MSEy = sum(errory)/length(errory);
